use strict;
use locale;

if ( $#ARGV != 1 ) {
    die "Usage : ", $0, " lemme rpertoire\n";
}

my $lemme = $ARGV[0];
my $repertoire = $ARGV[1];

opendir ( REP, $repertoire ) or 
    die "Impossible d'ouvrir ", $repertoire, " : ", $!, "\n";
my @fichiers = readdir( REP );
closedir ( REP );

my @fichierstag = grep (/\.tag$/, @fichiers);

foreach my $fichier ( sort @fichierstag ) {
    open ( FIC, "<", $repertoire."/".$fichier) or 
	warn "Erreur d'ouverture de ",$fichier, " :" ,$!, "\n";
    
    while ( my $ligne = <FIC> ){
	chomp $ligne;
	my @t = split ( /\t/, $ligne );
	
	if ( $t[2] eq $lemme ) {
	    print $t[0], "\t", $fichier,"\n";
	}
    }
    close ( FIC );
}


