use strict;
use locale;

my %freq;

while ( my $ligne = <STDIN> ) {
    chomp $ligne;
    my ( $forme, $categorie, $lemme ) = split( /\t/, $ligne );
    my $couple = lc($forme) . "\t" . $categorie;
    $freq{$couple}++;
}

foreach my $couple 
    ( sort { ( $freq{$b} <=> $freq{$a} ) or ( comparer($a, $b) ) } 
     keys %freq) {
	print $couple, "\t", $freq{$couple}, "\n";
}

sub comparer {
  my $couple_a = shift @_;
  my $couple_b = shift @_;
  my ( $forme_a, $categorie_a ) = split( /\t/, $couple_a );
  my ( $forme_b, $categorie_b ) = split( /\t/, $couple_b );
  return( 
    ($forme_a cmp $forme_b) or ($categorie_a cmp $categorie_b) );
}
