use strict;
use locale;
use Getopt::Std;
our ($opt_l, $opt_m, $opt_M);
$opt_l = 5;
$opt_m = 3;
$opt_M = 8;
getopts("l:m:M:");
if ($#ARGV != 1){ 
    die "Usage : ", $0, " [-m TAILLE_MINIMALE_RADICAL] 		   [-M TAILLE_MAXIMALE_SUFFIXE] 		              [-l NOMBRE_MINIMAL_OCCURRENCES] 		               LEXIQUE_BASES LEXIQUE_DERIVES\n";
}
my %bases = %{analyser_lexique($ARGV[0])};
my %derives = %{analyser_lexique($ARGV[1])};
my %schemas;
foreach my $radical (keys %derives){
    if (defined($bases{$radical})){
	foreach my $suff1 (keys %{$bases{$radical}}){
	    foreach my $suff2 (keys %{$derives{$radical}}){
		$schemas{$suff1}{$suff2} ++;
	    }
	}
    }
}
foreach my $suff1 (keys %schemas){
  foreach my $suff2 (keys %{$schemas{$suff1}}){
    if (($schemas{$suff1}{$suff2} >= $opt_l) and                   ($suff1 ne $suff2)){
      print $suff1, "\t", $suff2, "\t",                     $schemas{$suff1}{$suff2}, "\n" ;
    }
  }
}
sub analyser_lexique{
    my ($fichier) = @_;
    my %lex;
    open(LEX, "<", $fichier) or die "impossible d'ouvrir ", $fichier;
    while (my $ligne = <LEX>){
	chomp($ligne);
	my ($forme, $lemme, $cat) = split(/\t/, $ligne);
	my $c = substr($cat, 0, 1);
	my $l = length($lemme); 
	my $mg = $l - $opt_M;   
	my $m; 
	if ($mg < $opt_m){
	    $m = $opt_m;
	}
	else{
	    $m = $mg;
	}
	for(my $i = $m; $i <= $l; $i++){
	    $lex{substr($lemme, 0, $i)}                            {substr($lemme, $i) . "/" . $c} = 1 ;
	}
    }
    close(LEX);
    return(\%lex);
}
