use strict;
use locale;
use XML::DOM;

if ( $#ARGV != 0 ) {
    die "Usage : ", $0, " fichier_xml\n";
}

my $parseur = new XML::DOM::Parser;
my $doc = $parseur->parsefile( $ARGV[0] );

my $element_modification= $doc->createElement("modification_info");
my $element_auteur = $doc->createElement( "author" );
my $texte_auteur = $doc->createTextNode( $0 );
$element_auteur->appendChild( $texte_auteur );
$element_modification->appendChild( $element_auteur );

my $element_date = $doc->createElement( "date" );
my @tab_date = localtime;
my $date = $tab_date[3]."-".( $tab_date[4]+1 )."-".
           ( $tab_date[5]+1900 );
my $texte_date = $doc->createTextNode( $date );
$element_date->appendChild ( $texte_date );
$element_modification->appendChild( $element_date );

my $entete = $doc->getElementsByTagName("head")->[0];
$entete->appendChild( $element_modification );

foreach my $element_kinesic (
	  @{$doc->getElementsByTagName("kinesic_action")}){
    $element_kinesic->getParentNode->removeChild($element_kinesic);
}

print $doc->toString; 
